import requests
from lxml import etree

_last_response = None
_headers = {}
_params = {}

def get_web_text(url):
    global _last_response
    _last_response = requests.get(url)
    return _last_response.text

def get_xpath_text(ron_response, xpath_expr):
    global _last_response
    if not _last_response:
        return "未检测到HTML"
    tree = etree.HTML(ron_response)
    elems = tree.xpath(xpath_expr)
    return elems

def by_attr(tag: str, attr: str, value: str) -> str:
    return f"//{tag}[@{attr}='{value}']"

def extract_attr(xpath: str, attr: str, all=False):
    return f"{xpath}/@{attr}"

def extract_text(xpath: str, all=False):
    return f"{xpath}/text()"

def get_book_by_index(xpath: str, index: int):
    return f"{xpath}[{index}]"

def get_nth_last_book(xpath: str, n: int):
    return f"{xpath}[last()-{n - 1}]"

def get_next_text(xpath: str, Text: str):
    return f"{xpath}/{Text}"


