//% color="#1E90FF" iconWidth=30 iconHeight=30
namespace webcrawler {
    //% block="通过GET请求 [URL] 获取HTML" blockType="reporter"
    //% URL.shadow="string" URL.defl="https://xxxxx.com"
    export function getWebText(parameter: any, block: any) {
        const url = parameter.URL.code;
        Generator.addImport("from requests_lxml_ext import get_web_text");
        Generator.addCode( `get_web_text(${url})`);
    }

    //% block="解析[HTML]使用 XPath 提取文本 [XPATH]" blockType="reporter"
    //% HTML.shadow="string" HTML.defl="HTML"
    //% XPATH.shadow="string" XPATH.defl="XPath"
    export function getXPathText(parameter: any, block: any) {
        var HTML=parameter.HTML.code;
        const xpath = parameter.XPATH.code;
        Generator.addImport("from requests_lxml_ext import get_xpath_text");
        Generator.addCode( `get_xpath_text(${HTML},${xpath})`);
    }


    //% block="按属性查找 标签:[tag] 属性:[attr] 值:[value] " blockType="reporter"
    //% tag.shadow="string" tag.defl="body"
    //% attr.shadow="string" attr.defl="name"
    //% value.shadow="string" value.defl="xxxx"
    export function command_request_custom_text(parameter: any, block: any) {
        var tag=parameter.tag.code;
        var attr=parameter.attr.code;
        var value=parameter.value.code;
        Generator.addImport("from requests_lxml_ext import by_attr");
        Generator.addCode(`by_attr(${tag},${attr},${value})`);
        
    }   

    //% block="提取 XPath:[XPATH] 属性[attr]的内容" blockType="reporter"
    //% XPATH.shadow="string" XPATH.defl="XPath"
    //% attr.shadow="string" attr.defl="content"
    export function extract_attr(parameter: any, block: any) {
        var attr=parameter.attr.code;
        var xpath = parameter.XPATH.code;
        Generator.addImport("from requests_lxml_ext import extract_attr");
        Generator.addCode( `extract_attr(${xpath},${attr})`);
    }


    //% block="提取 XPath:[XPATH] 的文本内容" blockType="reporter"
    //% XPATH.shadow="string" XPATH.defl="XPath"
    export function extract_text(parameter: any, block: any) {
        var xpath = parameter.XPATH.code;
        Generator.addImport("from requests_lxml_ext import extract_text");
        Generator.addCode( `extract_text(${xpath})`);
    }

    //% block="选择 [XPATH] 的第 [index] 个标签" blockType="reporter"
    //% XPATH.shadow="string" XPATH.defl="XPath"
    //% index.shadow="number" index.defl="1"
    export function get_book_by_index(parameter: any, block: any) {
        var index=parameter.index.code;
        var xpath = parameter.XPATH.code;
        Generator.addImport("from requests_lxml_ext import get_book_by_index");
        Generator.addCode( `get_book_by_index(${xpath},${index})`);
    }

    //% block="选择 [XPATH] 的倒数第 [n] 个标签" blockType="reporter"
    //% XPATH.shadow="string" XPATH.defl="XPath"
    //% n.shadow="number" n.defl="1"
    export function get_nth_last_book(parameter: any, block: any) {
        var n=parameter.n.code;
        var xpath = parameter.XPATH.code;
        Generator.addImport("from requests_lxml_ext import get_nth_last_book");
        Generator.addCode( `get_nth_last_book(${xpath},${n})`);
    }
	
    //% block="[XPATH] / [Text] " blockType="reporter"
    //% XPATH.shadow="string" XPATH.defl="XPath"
    //% Text.shadow="string" Text.defl="n"
    export function get_next_text(parameter: any, block: any) {
        var Text=parameter.Text.code;
        var xpath = parameter.XPATH.code;
        Generator.addImport("from requests_lxml_ext import get_next_text");
        Generator.addCode( `get_next_text(${xpath},${Text})`);
    }


    function replaceQuotationMarks(str:string){
            str=str.replace(/"/g, ""); //去除所有引号
            return str
    }
}